/* GCC */
#include <stdio.h>
#include <utility>

#define N_MAX 100000

#define pii pair <short,short>
#define mp make_pair

using namespace std;
int n,i,j;
float maxslope = (float) 0;
pair <pii,pii> ans = mp(mp(30001,30001),mp(30001,30001));

float get_slope(pii x1, pii x2) {
    if (x1.second == x2.second) return 0;
    float d = ((float) x1.first - (float) x2.first) / ((float) x1.second - (float) x2.second);
    return d > 0 ? d : -d;
}

pair <pii,pii> min(pair <pii,pii> x1, pair <pii,pii> x2 = ans) {
    if (x1.first.second != x2.first.second) return x1.first.second < x2.first.second ? x1 : x2;
    if (x1.first.first != x2.first.first) return x1.first.first < x2.first.first ? x1 : x2;
    if (x1.second.second != x2.second.second) return x1.second.second < x2.second.second ? x1 : x2;
    if (x1.second.first != x2.second.first) return x1.second.first < x2.second.first ? x1 : x2;
    return x1;
}

int main() {
    freopen("slope.in","r",stdin);
    freopen("slope.out","w",stdout);
    scanf("%d",&n);
    pii nails[n];
    for (i = 0; i < n; ++i) {
        int a,b;
        scanf("%d %d",&a,&b);
        nails[i] = mp(a,b);
    }

    for (i = 0; i < n; ++i) {
        for (j = i; j < n; ++j) {
            float slope = get_slope(nails[i],nails[j]);
            if (slope != 0 && slope >= maxslope) {
                maxslope = slope;
                ans = min(mp(nails[i],nails[j]));
            }
        }
    }
    if (maxslope == (float) 0) {
        printf("%d\n",0);
        return 0;
    }

    printf("%d %d %d %d\n", ans.first.first, ans.first.second, ans.second.first, ans.second.second);
    return 0;
}
