/* GCC */

#include <iostream>
#include <fstream>
#include <math.h>

using namespace std;

__int16 Money, hr10, hr20;
int r;

__int64 Factorial(__int64 A)
{
    if (A == 0) return 1;
    return A*Factorial(A-1);
}
__int64 PathsAmo(int A, int B)
{
    return Factorial(A+B)/(Factorial(A)*Factorial(B));
}
__int64 PathsAmo(int A)
{
    __int64 factA = Factorial(A);
    return Factorial(2*A)/(factA*factA);
}
int main()
{
    __int64 IntAnswer = 0;

    ifstream fin("cash.in",ios_base::in);

    fin >> hr20;
    fin >> hr10;
    fin >> Money;
    fin >> r;

    fin.close();

    int x = hr20;
    int y = hr10;

    //limit
    //x -= Money;
    if (Money >= hr20)
        IntAnswer = PathsAmo(x,y);
    else if (x > y)
    {
        int WrongAreaSize = x-Money;
        if (WrongAreaSize <= y)
        {
            if (WrongAreaSize <= 0)
                IntAnswer = PathsAmo(x,y);
            else
                IntAnswer = PathsAmo(x,y)-x-y;
        }
        else
            IntAnswer = PathsAmo(x-(WrongAreaSize-y),y)-(x-(WrongAreaSize-y))-y;
    }
    else
    {
        int WrongAreaSize = x-Money;
        if (WrongAreaSize <= 0)
            IntAnswer = PathsAmo(x,y);
        else
            IntAnswer = PathsAmo(x,y)-x-y;
    }

    ofstream fout("cash.out",ios_base::out);

    if (r == 0)
        fout << IntAnswer;
    else
        fout << IntAnswer%r;

    fout << endl;
    fout.close();

    return 0;
}
