/* GCC */
#include <fstream>
#include <utility>
#include <cmath>
#include <algorithm>

#define arx(i) ar[i].second
#define ary(i) ar[i].first
using std::abs;

int main(void)
{
    size_t n = 0;
    double check = -1, temp = 0;
    std::ifstream in("slope.in");
    in >> n;
    std::pair<double, double>* ar = new std::pair<double, double>[n];
    for(size_t i = 0; i < n; i++)
               in >> arx(i) >> ary(i);
    in.close();
    std::sort(ar, ar+n);
    size_t ans_j = 0, ans_k = 0;
    for(size_t i = 0; i < n; i++)
    {
               in >> arx(i) >> ary(i);
               for(size_t j = 0; j < i; j++)
               {
                          if(ary(i) != ary(j))
                          {
                                    temp = abs((arx(i)-arx(j))/(ary(i)-ary(j)));
                                    if(temp > check)
                                    {
                                            check = temp;
                                            ans_j = j;
                                            ans_k = i;
                                    }
                          }
               }
    }
    std::ofstream out ("slope.out");
    if(check == -1)
             out << 0;
    else
    {
        if(ary(ans_j) < ary(ans_k))
                      out << arx(ans_j) << ' ' << ary(ans_j) << ' ' << arx(ans_k) << ' ' << ary(ans_k);
        else
                      out << arx(ans_k) << ' ' << ary(ans_k) << ' ' << arx(ans_j) << ' ' << ary(ans_j);
    }
    out << std::endl;
    out.close();
    delete[] ar;
    return 0;
}
