/* GCC */

#include <iostream>
#include <vector>

using namespace std;
typedef long long LL;

int r;

LL C (int n, int k)
{
    LL res = 1;

    for (int i = k + 1; i <= n; i++)
        res = res * i;

    for (int i = 2; i <= n - k; i++)
        res = res / i;

    if (r != 0)
        res %= r;

    return res;
}

LL f (int m, int n, int p)
{
    LL ans = 0;

    if (n == 1 && m == 0)
        return 1;
    if (n == 0 && m == 1 && p == 0)
        return 0;
    if (n == 0 && m == 1 && p > 0)
        return 1;

    if (n > 0)
        ans += f (m, n - 1, p + 1);

    if (r != 0)
        ans %= r;

    if (m > 0 && p > 0)
        ans += f (m - 1, n, p - 1);

    if (r != 0)
        ans %= r;

    return ans;
}

int main ()
{
    freopen ("cash.in", "r", stdin);
    freopen ("cash.out", "w", stdout);
    int m, n, p;
    LL ans = 0;

    cin >> m >> n >> p >> r;

    if (m <= 10 && n <= 10 && p <= 10)
    {
        cout << f (m, n, p) << endl;
        return 0;
    }
    if (m == n + p)
    {
        cout << 1 << endl;
        return 0;
    }
    if (m <= p) // m <= p
    {
        cout << C (m+n, m) << endl;
        return 0;
    }

    if (p == 0) // p == 0
    {
        n -= 1;
        p += 1;
        LL ans;
        for (int k = 0; k <=p; k++)
        {
            ans = C (m + n - (k+1), m-k);
            if (r != 0)
                ans %= r;
        }

        cout << ans << endl;

        return 0;
    }

    return 0;
}







































































