/* GCC */

#include <iostream>
#include <fstream>
#include <cmath>
#include <vector>
#include <utility>
using namespace std;

struct nd
{
    int x;
    int y;
};

int main()
{
    ifstream fin("slope.in");
    ofstream fout("slope.out");
    int n = 0;
    fin >> n;
    nd* best = new nd[n];
    int head  = 0;
    nd* a = new nd[n];
    for (int i=0;i<n;++i)
        fin >> a[i].x >> a[i].y;
    double maxm = 0;
    for (int i=0;i<n-1;++i)
        for (int j=i+1;j<n;++j)
        {
            bool chk= true;
            double rat;
            if (a[i].y - a[j].y != 0)
                 rat = abs((double)(a[i].x - a[j].x)/(a[i].y - a[j].y));
            else
            {
                rat = 0;
                chk = false;
            }
            if ( chk && rat >= maxm)
            {
                if (rat > maxm)
                {
                    memset(best, 0, n*sizeof(best));
                    head = 0;
                }
                maxm = rat;
                best[head].x = i;
                best[head++].y = j;
            }
        }
    for (int i = 0;i<head;++i)
       if (a[best[i].x].y > a[best[i].y].y)
       {
            int temp = best[i].x;
            best[i].x = best[i].y;
            best[i].y = temp;
       }


    for (int i = 1;i<head;++i)
    {
        nd x = best[i];
        int j;
        for(j = i-1;j>=0 && (a[best[i].x].y < a[best[j].x].y);--j)
        {
            best[j + 1] = best[j];
        }
        best[j+1] = x;

    }
    for (int i = head-1;i>=0;--i)
        if (a[best[i].x].y > a[best[0].x].y) head--;

    for (int i = 1;i<head;++i)
    {
        nd x = best[i];
        int j;
        for(j = i-1;j>=0 && (a[best[i].x].x < a[best[j].x].x);--j)
        {
            best[j + 1] = best[j];
        }
        best[j+1] = x;

    }
    for (int i = head-1;i>=0;--i)
        if (a[best[i].x].x > a[best[0].x].x) head--;

    for (int i = 1;i<head;++i)
    {
        nd x = best[i];
        int j;
        for(j = i-1;j>=0 && (a[best[i].y].y < a[best[j].y].y);--j)
        {
            best[j + 1] = best[j];
        }
        best[j+1] = x;

    }

    for (int i = head-1;i>=0;--i)
        if (a[best[i].y].y > a[best[0].y].y) head--;

    for (int i = 1;i<head;++i)
    {
        nd x = best[i];
        int j;
        for(j = i-1;j>=0 && (a[best[i].y].x < a[best[j].y].x) ;--j)
        {
            best[j + 1] = best[j];
        }
        best[j+1] = x;
    }
    for (int i = head-1;i>=0;--i)
        if (a[best[i].y].x > a[best[0].y].x) head--;

    for (int i = 0;i<head;++i)
    fout << a[best[i].x].x << ' ' << a[best[i].x].y << ' ' << a[best[i].y].x << ' '
     << a[best[i].y].y << endl;
     if (head == 0) fout << 0 << endl;
    delete[] best;
    delete[] a;
    fin.close();
    fout.close();
    return 0;
}
