/* GCC */
#define _USE_MATH_DEFINES
#pragma comment(linker,"/STACK:100000000")
#include <iostream>
#include <algorithm>
#include <memory.h>
#include <cstring>
#include <sstream>
#include <cstdlib>
#include <fstream>
#include <complex>
#include <string>
#include <bitset>
#include <vector>
#include <cstdio>
#include <ctime>
#include <cmath>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef complex <double> cd;

const bool db=false;

#define mp make_pair
#define pb push_back
#define ppb pop_back
#define sd second
#define fs first

#define inf 1000000007
#define nmax 2000
#define mmax 20000
#define eps 1e-6

int main()
{
    freopen("cash.in","r",stdin); freopen("cash.out","w",stdout);
    ios::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    ll n,m,p,r;
    cin>>n>>m>>p>>r;
    ll dp[n+2][m+2];
    memset(dp,0,sizeof(dp));
    for (ll j=0;j<=m;j++)
        dp[0][j]=1;
    for (ll i=1;i<=n;i++)
    {
        for (ll j=0;j<=m;j++)
        {
            if (i<=j+p)
            {
                if (j>0)
                    dp[i][j]=dp[i-1][j]+dp[i][j-1];
                else dp[i][j]=1;
            }
        }
    }
    if (r)
        cout<<dp[n][m]%r<<"\n";
    else cout<<dp[n][m]<<"\n";
    return 0;
}
