/* GCC */
#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <ctime>

using namespace std;

int n, m, p;
long long r;

long long solve(int left10, int left20, int cnt10)
{
    if (left10 == 0 && left20 == 0) return 1;
    long long res = 0;
    if (cnt10 == 0)
    {
        if (left10)
            res = solve(left10 - 1, left20, cnt10 + 1); //only 10
    }
    else
    {
        long long cur = left10 ? solve(left10 - 1, left20, cnt10 + 1) : 0;
        if (r) cur %= r;
        res += cur;
        cur = left20 ? solve(left10, left20 - 1, cnt10 - 1) : 0; //10 and 20
        if (r) cur %= r;
        res += cur;
    }
    if (r) res %= r;
    return res;
}


int main()
{
    freopen("cash.in", "r", stdin);
    freopen("cash.out", "w", stdout);
    scanf("%d %d %d %lld", &m, &n, &p, &r);
    long long ans = solve(n, m, p);
    printf("%lld\n", ans);
    return 0;
}